#!/usr/bin/env bash

set -eux

BUILD_TYPE="${BUILD_TYPE:-RelWithDebInfo}"

if [ "${USE_CLANG:-}" == "yes" ]
then
	export CC=$(command -v clang)
	export CXX=$(command -v clang++)
fi

[[ -d build ]] && rm -rf build
mkdir -p build && cd build
cmake -DCMAKE_BUILD_TYPE=${BUILD_TYPE} .. && make all package

sc3dev-packager --owner ${OWNER:-sc} debian --comp ${COMPONENT:-dev} put *.deb
sc3dev-packager --owner ${OWNER:-sc} generic put *.sh *.tar.gz
